/*
 * Copyright 2019 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import kotlinx.serialization.*
import kotlinx.serialization.json.*
import kotlinx.serialization.schema.*

@Serializable
data class Data(val a: Int, val b: String = "42")

fun main(args: Array<String>) {
    println(">> Sample of Json schema: ")
    println(Json(JsonConfiguration.Stable.copy(prettyPrint = true)).stringify(JsonObjectSerializer, JsonSchema(Data.serializer().descriptor)))
    println(">> Sample of Protobuf schema: ")
    println(ProtoSchema(Data.serializer().descriptor))
}
